import Axios, { AxiosError, AxiosResponse } from "axios";
import { linkGetCategory, linkGetCategoryTreeView, getAllSubCategoryList, linkGetAllCategories, linkGetAllSubCategories } from "./apiEndpoints";

class categoryDataAccess {
   getCategoryTreeView = () => {
      return Axios.get(linkGetCategoryTreeView)
         .then((response: AxiosResponse) => {
            if (response.data.success) {
               return response.data.data;
            } else {
               throw new Error(response.data.message);
            }
         })
         .catch((error: AxiosError) => {
            throw new Error(error.message);
         });
   };
   getCategory = (categoryId) => {
      return Axios.get(linkGetCategory + categoryId)
         .then((response: AxiosResponse) => {
            if (response.data.success) {
               return response.data.data;
            } else {
               throw new Error(response.data.message);
            }
         })
         .catch((error: AxiosError) => {
            throw new Error(error.message);
         });
   };

   getSubCategory = (categorySlag) => {
      return Axios.get(getAllSubCategoryList + "/" + categorySlag)
      .then((response: AxiosResponse) => {
         return response.data;
         })
         .catch((error: AxiosError) => {
            return (error.message);
         });
   };

   getAllCategories = (perPage = 12, page = 1) => { 
      return Axios.get(linkGetAllCategories + "?per_page=" + perPage + "&page=" + page)
         .then((response: AxiosResponse) => {
            if (response.data.success) {
                 return response.data.data;
            } else {
               throw new Error(response.data.message);
            }
         })
         .catch((error: AxiosError) => {
            throw new Error(error.message);
         });
  };


  getAllSubCategories = (categorySlug:string, perPage = 12, page = 1) => {
   return Axios.get(linkGetAllSubCategories + categorySlug + "?per_page=" + perPage + "&page=" + page)
      .then((response: AxiosResponse) => {
         if (response.data.success) {
              return response.data.data;
         } else {
            throw new Error(response.data.message);
         }
      })
      .catch((error: AxiosError) => {
         throw new Error(error.message);
      });
   };


}
export default new categoryDataAccess();
